ravSpeed = {
  lastSpeeds = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
  lastSpeedIndex = 1,
  lastPos = nil,
  initDone = false,
}
ravSpeed.Default = {
  ctrlPos = {TOPLEFT, TOPLEFT, 20, 20},
  referenceSpeed = 250,
}


function ravSpeed.init(eventCode, addOnName)
  if (addOnName ~= "ravSpeed") then return end
  ravSpeed.SV = ZO_SavedVars:New("ravSpeed_SV", 1, nil, ravSpeed.Default, nil)
  
  ravSpeedCtrl:SetHandler("OnMouseUp", ravSpeed.saveWindowPos)
  local point, relativePoint, offsetX, offsetY = unpack(ravSpeed.SV.ctrlPos)
  ravSpeedCtrl:ClearAnchors()
  ravSpeedCtrl:SetAnchor(point, ravSpeedCtrl.parent, relativePoint, offsetX, offsetY)
  ravSpeed.initDone = true
end


function ravSpeed.saveWindowPos()
  local isValidAnchor, point, relativeTo, relativePoint, offsetX, offsetY = ravSpeedCtrl:GetAnchor()
  if (isValidAnchor) then
    ravSpeed.SV.ctrlPos = {point, relativePoint, offsetX, offsetY}
  end
end


function ravSpeed.update()
  if ravSpeed.initDone == false then return end
  if SCENE_MANAGER:IsShowing("worldMap") then return end
  
  SetMapToMapListIndex(1)
  local xPos, yPos = GetMapPlayerPosition('player')
  
  SetMapToPlayerLocation()
  local isCyrodiil = GetCurrentMapZoneIndex() == 37
  local isDungeon = GetMapType() == 1 and GetMapContentType() == 2
  
  if ravSpeed.lastPos ~= nil then
    local lastX, lastY = unpack(ravSpeed.lastPos) 
    local xd = xPos - lastX
    local yd = yPos - lastY
    local dist = math.sqrt(xd * xd + yd * yd)


    local timeDelta = GetFrameDeltaTimeMilliseconds()
    local distPerMs = dist / timeDelta
      
    ravSpeed.lastSpeedIndex = math.mod(ravSpeed.lastSpeedIndex + 1, #ravSpeed.lastSpeeds)
    ravSpeed.lastSpeeds[ravSpeed.lastSpeedIndex] = distPerMs
  end
  
  ravSpeed.lastPos = {xPos, yPos}
  
  local meanSpeed = 0
  for i = 1, #ravSpeed.lastSpeeds do
    meanSpeed = meanSpeed + ravSpeed.lastSpeeds[i] 
  end
  
  meanSpeed = meanSpeed / #ravSpeed.lastSpeeds
  meanSpeed = meanSpeed * 1000000000
  meanSpeed = math.floor(meanSpeed+0.5)

  if isCyrodiil and not isDungeon then
    meanSpeed = meanSpeed / 0.45
  elseif not isCyrodiil and isDungeon then
    meanSpeed = meanSpeed * 10
  end
  
  pctSpeed = 0
  if ravSpeed.SV.referenceSpeed ~= nil and ravSpeed.SV.referenceSpeed > 0 then
    pctSpeed = math.floor(meanSpeed / ravSpeed.SV.referenceSpeed * 100 + 0.5)
  end 
  
  ravSpeedCtrlLabel:SetText(string.format("%04dups / %04d%%", meanSpeed, pctSpeed))
end


function ravSpeed.commandHandler(text)
  if (text == nil or text == "" or text == "[Empty String]") then 
    d("Usage: /ravspeed 250")
    return
  end
  ravSpeed.SV.referenceSpeed = tonumber(text)
end

SLASH_COMMANDS["/ravspeed"] = ravSpeed.commandHandler
EVENT_MANAGER:RegisterForEvent("ravSpeed", EVENT_ADD_ON_LOADED, ravSpeed.init)
